#!/usr/bin/wish

# test matrix module

set sigma 30

#----------------------------------------------------------------------------
# testMatImg : dump c++ matrix into image
#----------------------------------------------------------------------------
proc testMatImg { matrix imgName {zoom 3} } {

  matrix_put_rgb_ppm $matrix "/tmp/.temp.ppm"
  destroy $imgName
  image create photo $imgName -format ppm -file "/tmp/.temp.ppm" 
}

proc run { mat sigma } {
	set num 0
	for {set i 0} {$i<10} {incr i} {
	  # matrix_gaussian_random_matrix $mat $sigma
	  matrix_gray_random_matrix $mat $sigma
	  testMatImg $mat MAT0
	  incr num
	  update
	}
}

# 1. load in matrix module
load ./matrix.so

# 2. init random matrix
set mat [new_matrix 200 200]

# 3. test performance
set num 0
for {set i 0} {$i<100} {incr i} {
  image create photo MAT$i 
  label .mat$i -image MAT$i ; pack .mat$i -side top
}
label .num -textvariable num; pack .num -side top

entry .sigma -textvariable sigma -width 5 ; pack .sigma -side top

button .next -text "run" -command { run $mat $sigma ; }
pack .next -side top

button .q -text "quit" -command exit ; pack .q -side top

for {set i 0} {$i<100} {incr i} {
  matrix_gray_random_matrix $mat $sigma
  testMatImg $mat MAT0
  incr num
  update
}

matrix_put_rgb_ppm $mat "temp.ppm"

# 3. print
# set fp [open "|[matrix_print_matrix $mat]" "r"]
# set str [read $fp]
# close $fp

# set fp [open "dump" w]
# puts $fp $str
# close $fp
