//----------------------------------------------------------------------------
// 
//	file: inputlisttest.cc
// 
//	function: test inputlist class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Feb  4 01:24:42 CST 1999
// 
//	$Revision: 1.2 $ $Date: 2000/01/30 14:55:55 $
//	$Log: inputlisttest.cc,v $
//	Revision 1.2  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.1  1999/02/09 07:56:44  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: geninptest.cc
// 
//	function: test geninput class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sat Sep 12 03:45:54 CDT 1998
// 
//	Revision: 1.1 Date: 1998/10/16 10:35:21 
//	Log: geninptest.cc,v 
//	Revision 1.1  1998/10/16 10:35:21  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
#include <window.h>
#include <math.h>
#include <iostream.h>
#include <stream.h>
#include <nnview/real.h>
#include <nnview/matrix_window.h>
#include <nnview/plot_window.h>
#include <nnview/tool_window.h>
#include <nnview/util.h>
#include <nnview/geninput.h>
#include <nnview/disputil_window.h>
#include <nnview/inputlist.h>

main_window     *mw;
matrix_window   *matw;
callback_button *runit;
callback_button *clearit;
geninput 	*input;
inputlist	*list;

REAL **mat;

int N = 25;

#define randsign (drand48()>0.5?-1:1)

// the actual action takes place here.
void run() {

  //static int i, j;
  static int count;

  int x, y, x2, y2;

  x = (int)(drand48()*N);
  y = (int)(drand48()*N);
  x2 = (int)(drand48()*N);
  y2 = (int)(drand48()*N);
  
  for (int i=0; i<360; ++i) {

  // add inputs to list
  list->clear_specs();

  list->add_spec(x=(x+=(int)(drand48()*2)*randsign)%N,
		 y=(y+=(int)(drand48()*2)*randsign)%N,2);
  list->add_spec(x2=(x2+=(int)(drand48()*2)*randsign)%N,
		 y2=(y2+=(int)(drand48()*2)*randsign)%N,(REAL)2.0);
  list->add_spec(N/2,N/2,(REAL)1.0,(REAL)5.0,(REAL)i);

	list->add_inputs();
  /*
  	input->clear_input();
 	REAL sigmax = 2; //(REAL)(drand48()*2+1);
	REAL sigmay = 8; //REAL sigmay = (REAL)(drand48()*8+1);
	REAL angle  = (count)%360; //REAL angle  = (REAL)(drand48()*360.0);
  	cout << "sigmax = " << sigmax 
	     << " sigmay = " << sigmay
	     << " angle = " << angle << endl;
  	input->add_input(N/2,N/2,
			sigmax, sigmay, angle);
			// 10,10,
			// 3,(REAL)0.0,0.0);//(REAL)angle);	
			//(int)(drand48()*N),(int)(drand48()*N),
			//(REAL)(drand48()*8+3),(REAL)(drand48()*16+3),
			//(REAL)(drand48()*360.0));
  */
  	matw->redraw();
  	XFlush(display);
  	count ++;
  }
  //cout << "run\n";
}

// clear mat
void clear() {
  disputil_window *dw = new disputil_window("disputil",mat,N,N,20);
  // input->clear_input();
  matw->redraw();
  XFlush(display);
  cout << "clean\n";
}

// Main
int main(int argc, char *argv[]) {

  mat = new REAL* [N];
  for (int i=0; i<N; ++i) mat[i] = new REAL [N];

  // setup input class
  input = new geninput(mat,N,N,INP_SQR,INP_NORM_SQRT);
  input->clear_input();

  list = new inputlist(20,input);

  // setup the windows
  mw = new main_window(argv[0],480,260);

  matw = new matrix_window(*mw,240,240,0,0,0,60,COLOR,N,N,mat);

  runit = new callback_button(*mw,"Run",run,
                mw->width/4,20,mw->width/2,mw->height-20);

  clearit = new callback_button(*mw,"Clean",clear,
                mw->width/4,20,mw->width*1/4,mw->height-20);

   
  // add quit button
  new quit_button(*mw,mw->width/4,20,mw->width*3/4,mw->height-20);

  
  // start main loop
  mw->main_loop();

}
  
