# bayesclassifier.m 
# function [C] = bayesclassifier(x,data1, data2)
#	C : class boundary
#	data1: n measurement h value for class 1 inputs
#	data2: n measurement h value for class 2 inputs

function [C] = bayesclassifier(x,data1, data2)

	# common values
	n1 = length(data1);
	n2 = length(data2);

	# common counts
	range1 = max(data1)-min(data1);
	range2 = max(data2)-min(data2);
	[hist1, idx1] = hist(data1,range1+1);
	[hist2, idx2] = hist(data2,range2+1);

	xidx1 = length(idx1);
	for i=1:length(idx1)
		if x<idx1(i)
			xidx1 = i;
			break;
	  	endif	
	endfor

	xidx2 = length(idx2);
	for i=1:length(idx2)
		if x<idx2(i)
			xidx2 = i;
			break;
	  	endif	
	endfor

	# compare posterior probability P(Ck|x)
	#
	# 	first calc P(x|Ck)
	PxC1 = hist1(xidx1)/n1+0.00000001;
	PxC2 = hist2(xidx2)/n2+0.00000001;

	# calculate P(C1) and P(C2);
	PC1 = n1/(n1+n2);
	PC2 = n2/(n1+n2);

	if PxC1*PC1>(PxC2*PC2)
		C = 1;
	else 
		C = 2;
	endif
	
endfunction
