#!/usr/bin/perl

# calculate correlogram between two series

$usage = <<'EOF';
usage: correlogram.pl <binsize> < series.dat 
EOF

if ($#ARGV!=0) {
	print $usage;
	exit 0;
}

# initialize bin 
$binsize = $ARGV[0];
if ($binsize%2!=0) {
	$binsize++;
	print STDERR "binsize is odd -- added 1 to make it even.\n";
}
for($i=0; $i<$binsize+1; $i++) {
	$histo[$i] = 0;
}

# read raw data in
$i =0 ;
while (<STDIN>) {
	chop;
	($dat1,$dat2) = split(/[\s]+/);
	$raw[$i][0] = $dat1;
	$raw[$i][1] = $dat2;
	$i ++;
}

# use second column as reference. Scan from bin/2 - (max-bin/2)
for ($i=$binsize/2; $i<=$#raw-$binsize/2; ++$i){
	for ($j=-$binsize/2;$j<=$binsize/2;++$j) {
		$k = $j+$binsize/2;
		$histo[$k] += $raw[$i][0]*$raw[$i+$j][1];
	}
			
}

for($i=0; $i<$binsize+1; $i++) {
	$k = $i-$binsize/2;
	print "$k $histo[$i]\n";
}

	
