## usage: [Smax1] = circaperturefreq(Smax)
##
##	Smax=absolute spatial frequency preference matrix
##     
##
##      Finds the circular aperture for the specified Smax file
##     
##     By Subramonia Sarma <sps8556@cs.tamu.edu> on May 29 2002

function [Smax1] = circaperturefreq(Smax)
      
         # get size of matrix
	[rows, cols] = size(Smax);

        
        printf("cols = %d , rows = %d\n",cols,rows);
        

	Smax1 = zeros(rows,cols);   	
	
	xc=ceil(rows/2);
	yc=ceil(cols/2);

        printf("xc = %d , yc = %d\n",xc,yc);

	if (rows < cols)
	r=rows/2
	else
	r=cols/2;
	endif

	for i=1:rows
	for j=1:cols
	
        if (((abs(i-xc)**2)+(abs(j-yc)**2)) > (r**2))
	Smax1(i,j)=-1;
	else
	Smax1(i,j)=Smax(i,j);
	endif
	endfor
        endfor
            
	#save -ascii img1 nV;	

 
 endfunction

