# usage: [dX,dY,C] = grad(X) : return x, y, and combined gradient of matrix X
# in a n x n matrix of zeros (m < n)
function [dX, dY, C] = grad(inX,n) 

	if (nargin == 1)
		n = 1;
	endif

	maxx = max(vec(inX));
	X = inX/maxx;

	dX = rot90(rot90(rot90(vecdiff(rot90(X)),n)));
	dY = vecdiff(X,n);

	c = columns(dX);
	r = rows(dX);
	m = min([c,r]);
	mx = max([c,r]);
	c = columns(dY);
	r = rows(dY);
	m2 = min([c,r]);
	mx2 = max([c,r]);
	m = min([m,m2]);
	mx = max([mx,m2]);

	dX = dX(1:m,1:m);
	dY = dY(1:m,1:m);

	C = sqrt(dX.*dX + dY.*dY);

	if (n==1) 
		dX = [dX, zeros(m,1); zeros(1,mx)];
		dY = [dY, zeros(m,1); zeros(1,mx)];
		C =  [C, zeros(m,1); zeros(1,mx)];
	endif

endfunction


