## Copyright (C) 2000 uschoe
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## usage: logprobplot(X,th)
##
## plot log probability of matrix X after adding a small value th.
##

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function [nmax,nmin] = logprobplot (X,th)

	offsetted = X.+th;
	normalized = offsetted./(max(vec(offsetted)));
	nmax = max(vec(normalized));
	nmin = min(vec(normalized));
	logged = log10(normalized);
	yimage(logged,"hotmap");
	yimage(logged,"hsvmap3");
	yimage(logged,"graymap2");

endfunction

	

