 

# usage: th = topnpercent(X,p)
# 	find the threshold th for the top p*100 % of the whole
#	matrix values 
#	example:
#		th = topnpercent(X,0.75) : for top 75% point
#
#	original code : choe@tamu.edu
#	Change Log:
#	modified by   : B S Kumar 12/23/2002
#	changes t accomodate the aperture radius

#NUM_ZEROS FOR 256 = 14105
#hence non zeros = 51431

function th = topnpercent_circ(X,p)

	[r,c] = size(X);
	newX = vec(X);

	newX = newX(find(newX>0));
	diff = 47485 - length(newX);
	while (diff != 0)
		
		newX = [newX, 0];
		diff--;
	endwhile	

	printf("\n%.2f\t",p);
	
	# get histogram
	[n,x] = hist(vec(newX),r*10);

	# calculate cumulative sum of the histogram
	cumul = cumsum(n);
	
	# find p*100 % point
	s = sign(cumul.-(max(cumul)*p));
	
	bins = columns(s);
	for i=1:bins
		if (s(i)==1)
			th = x(i)
			break;
		endif
	endfor
endfunction
