# function [f,g,vf,vg,l1,l2] = histgaus(x,h)
#	returns f and g with same variance

function [nf,ng,vnf,vng,l1,l2] = histgaus(x,h)

	f = h;
	nf = f/sum(f);

	vnf = sum((x.^2).*nf);

	g = normal_pdf(x,0,vnf);
	ng = g/sum(g);

	vng = sum((x.^2).*ng);

	df = diff(sign(nf-ng));

	[mx,l2ix]=max(df);
	[mn,l1ix]=min(df);

	l1 = x(l1ix);
	l2 = x(l2ix);

endfunction

