#!/bin/sh

if [ $# != 1 ] ; then
        echo "usage: imgtodat <imagefile>"
        echo " output <imagefile>.dat (octave format)"
        exit
fi

if [ -f $1.ppm ] ; then
        echo "$1.ppm exists. Aborting."
        exit
fi

# convert to ppm
convert -comment imgtodat $1 $1.ppm

# get image dimension
dim=`strings $1.ppm | head -100 | grep -v \# | head -1`
echo "dim = $dim"

# convert to dat
sh -c "ppmtomat $dim $1.ppm > $1.dat"

# convert to octave matrix
mat2octave.pl $1.dat

# clean up
rm $1.ppm

echo "$1.dat was generated successfully."

