#!/usr/bin/perl

#
#print "usage: correl.pl \n";
#print "   input: <stdin>\n";
#print "   calculate Pearson's r for two column of input data\n";
#print "\n";

if ($#ARGV==0) {
   if ($ARGV[0] =~ /-l/) {
     $long = 1;
   } else {
     $long = 0;
     $prefix = $ARGV[0];
   }
} else {
   $long = 0;
}

$i=0;
while (<STDIN>) {

  chop;
  ($a[$i],$b[$i]) = split(/[\s]+/);
  $i++;

}

$num = $#a+1;
# print "samples  : $num\n";

# calc mean
$sum_a = 0;
$sum_b = 0;
for($i=0; $i<=$#a; ++$i) {
  $sum_a += $a[$i];
  $sum_b += $b[$i];
}

if ($sum_a == 0 || $sum_b == 0) {
  print "correl.pl: error - column(s) is(are) empty : $sum_a , $sum_b \n";
  if ($sum_a == 0) {$sum_a = 0.0000001;}
  if ($sum_b == 0) {$sum_b = 0.0000001;}
  # exit(2);
}

$mean_a = $sum_a/$num;
$mean_b = $sum_b/$num;
print "mean     : u_a = $mean_a, 	u_b = $mean_b\n" if $long;

# calc sum((x-u)^2)
$sum_sqrt_a = 0;
$sum_sqrt_b = 0;
for($i=0; $i<=$#a; ++$i) {
  $sum_sqrt_a += ($a[$i]-$mean_a)*($a[$i]-$mean_a);
  $sum_sqrt_b += ($b[$i]-$mean_b)*($b[$i]-$mean_b);
}
$sum_sqrt_a = sqrt($sum_sqrt_a);
$sum_sqrt_b = sqrt($sum_sqrt_b);
print "variance : s_a = $sum_sqrt_a, 	s_b = $sum_sqrt_b\n" if $long;

# calc pearson's r
$r = 0;
for($i=0; $i<=$#a; ++$i) {
  $r += ($a[$i]-$mean_a)*($b[$i]-$mean_b);
}
$r /= $sum_sqrt_a*$sum_sqrt_b;

print $prefix."correl coeff = $r\n";
