#!/usr/bin/perl

require "getopts.pl";
&Getopts('a');

$usage = <<EOF;
usage: sortbib.pl [-a] <bibfile>
	-a : remove annotations
	output: sorted, and annote field removed list
EOF

if ($#ARGV != 0) {
	print $usage;
	exit;
}

open(FP, $ARGV[0]);

$str = "";
while (<FP>) {

	if (/^%/) {
		next;
	}
	

   	if ($opt_a && /^[\s]+annote[\s]+\=/) {
		while (! /",/) {
			$_ = <FP>;
		}
		$_ = <FP>;
	}

	$str .= $_;

}

@bibarray = split(/@/,$str);

foreach $bib (@bibarray) {
	($rawkey,$rest) = split(/\n/,$bib,2);
	($junk,$key,$rest) = split(/[{,]/,$rawkey);

	if ($key =~ /:/) {
		$artkey_bib{"$key"} = "\@$bib";	
	} else {
		$bookkey_bib{"$key"} = "\@$bib";	
	}
	
}

foreach $key (sort(keys(%artkey_bib))) {
	print $artkey_bib{"$key"};
}

print "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";
print "% these are books \n";
print "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n";

foreach $key (sort(keys(%bookkey_bib))) {
	print $bookkey_bib{"$key"};
}

close (FP);
